; _createwnd
; draft v.2012-01-08

.386
.model flat,stdcall
option casemap:none

; ml   /I\masm32\include ...
; link /libpath:\masm32\lib ...

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32
inclib _createwnd_dll

WINFO struct
    v1     DWORD ?  ; Tid
    v2     DWORD ?  ; Pid
    v3     DWORD ?  ; Id
    v4     DWORD ?  ; Userdata
    v5     DWORD ?  ; Style
    v6     DWORD ?  ; ExStyle
    v7     DWORD ?  ; Left
    v8     DWORD ?  ; Top
    v9     DWORD ?  ; Width
    v10    DWORD ?  ; Height
    v11    DWORD ?  ; gaParent
    v12    DWORD ?  ; gwlParent
    v13    DWORD ?  ; gParent
    v14    DWORD ?  ; gwOwner
    v15    DWORD ?  ; lpClass
    v16    DWORD ?  ; lpSmName
    v17    DWORD ?  ; lpGwtName
WINFO ends

; ListToFile
; SubClass
; DlgProc

.const
 id      equ 100
 
.data

 _nb       db " !! THIS IS A TABLE !!",13,10
           db " !! Set your text editor to WORD-UNWRAP & MONOSPACED FONT (Courier, FixedSys,...) !!",13,10,13,10
 _head     db " #     Event/Message   Window    w  Tid   Pid   Id        *Id       Userdata  *Parent   gaParent  gwlParent getParent gwOwner   *Style    Style     *ExStyle  ExStyle   *hInst    [Pos,Size]  *[Pos,Size]    *Class - *Name / smName / gwtName",0
 _unhook1  db "+hkCBT",0
 _hook1    db "-hkCBT",0
 _unhook2  db "+hkCWP",0
 _hook2    db "-hkCWP",0
 _unhook3  db "+hkSHL",0
 _hook3    db "-hkSHL",0
 _unshw    db "+SHW",0 
 _shw      db "-SHW",0
 _shw_crea db " WindowCreated_   ",0
 _shw_dest db " WindowDestroyed_ ",0
 _WM_SHELLHOOK db "WM_"
 _shellhook db "SHELLHOOK",0
 _next     db 13,10,0
 _ft       db "_createwnd_%10.10lu.txt",0
; _event    db "%5.4d%s%8.8lX  %s%6.4lu%6.4lu%10.8lX  .%17.8lX  ... ""%s"" - ""."" / ""%s"" / ""%s""",0
 _event2   db "%5.4d%s%8.8lX  .  %6.4lu%6.4lu%10.8lX  .%17.8lX  ... ""%s"" - ""."" / ""%s"" / ""%s""",0

.data?
 hwnd      dd ?
 oldproc   dd ?
 hght      dd ?
 shm       dd ? 
 WM_SHELLHOOK dd ?
 icc  INITCOMMONCONTROLSEX <>

.code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetWinfo proc uses ebx hWnd:HWND,lpWi:DWORD
  local pid:DWORD
  local rt:RECT
  local buf1[MAX_PATH]:BYTE
  local buf2[MAX_PATH]:BYTE
  local buf3[MAX_PATH]:BYTE
  mov ebx,lpWi
  assume ebx:PTR WINFO
  invoke GetWindowThreadProcessId,hWnd,addr pid
  mov [ebx].v1,eax 
  mov eax,pid
  mov [ebx].v2,eax
  invoke GetWindowLong,hWnd,GWL_ID
  mov [ebx].v3,eax
  invoke GetWindowLong,hWnd,GWL_USERDATA
  mov [ebx].v4,eax
  invoke GetWindowLong,hWnd,GWL_STYLE
  mov [ebx].v5,eax
  invoke GetWindowLong,hWnd,GWL_EXSTYLE
  mov [ebx].v6,eax
  invoke GetWindowRect,hWnd,addr rt
  mov eax,rt.left
  mov [ebx].v7,eax
  mov eax,rt.top
  mov [ebx].v8,eax
  mov eax,rt.right
  sub eax,rt.left
  mov [ebx].v9,eax
  mov eax,rt.bottom
  sub eax,rt.top
  mov [ebx].v10,eax
  invoke GetAncestor,hWnd,GA_PARENT
  mov [ebx].v11,eax
  invoke GetWindowLong,hWnd,GWL_HWNDPARENT
  mov [ebx].v12,eax
  invoke GetParent,hWnd
  mov [ebx].v13,eax
  invoke GetWindow,hWnd,GW_OWNER
  mov [ebx].v14,eax
  invoke GetClassName,hWnd,addr buf1,MAX_PATH-1
  lea eax,buf1
  mov [ebx].v15,eax
  invoke SendMessage,hWnd,WM_GETTEXT,MAX_PATH-1,addr buf2
  lea eax,buf2
  mov [ebx].v16,eax
  invoke GetWindowText,hWnd,addr buf3,MAX_PATH-1
  lea eax,buf3
  mov [ebx].v17,eax
  assume ebx:nothing
  ret
GetWinfo endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ClearCount proc uses ebx
  mov ebx,id+2
  .while ebx<=id+5  ; 6                ; ?(Qs!=0)?
    invoke SetDlgItemInt,hwnd,ebx,0,0
    invoke GetDlgItem,hwnd,ebx
    invoke InvalidateRect,eax,0,1
    inc ebx
  .endw
  ret
ClearCount endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ListToFile proc uses ebx edi esi
  local	buf[1024]:BYTE
  local	bytes:DWORD
  invoke GetTickCount
  invoke wsprintf,addr buf,offset _ft,eax
  xor ebx,ebx
  invoke CreateFile,addr buf,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,ebx,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,ebx
  .if eax!=INVALID_HANDLE_VALUE
    mov edi,eax
    invoke SetFilePointer,edi,ebx,ebx,FILE_END
    invoke SendDlgItemMessage,hwnd,id,LB_GETCOUNT,ebx,ebx
    mov esi,eax
    dec ebx
    .while ebx!=esi
      .if ebx==-1
        invoke lstrcpy,addr buf,offset _nb
        invoke lstrcat,addr buf,offset _next
      .else
        invoke SendDlgItemMessage,hwnd,id,LB_GETTEXT,ebx,addr buf      
      .endif      
      invoke lstrcat,addr buf,offset _next
      invoke lstrlen,eax
      mov bytes,eax
      invoke WriteFile,edi,addr buf,bytes,addr bytes,0
      .break .if (!eax)
      inc ebx
    .endw
    invoke CloseHandle,edi
  .endif
  ret
ListToFile endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubClass proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  .if uMsg==WM_HSCROLL
    invoke SendDlgItemMessage,hwnd,id+1,uMsg,wParam,lParam
  .endif
  invoke CallWindowProc,oldproc,hWnd,uMsg,wParam,lParam
  ret
SubClass endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local rt:RECT
  local wi:WINFO
  local buf[1024]:BYTE
  local bu1[256]:BYTE
  local bu2[256]:BYTE
  local bu3[256]:BYTE

  mov eax,uMsg

  .if eax==WM_CLOSE
    invoke UninstallHook1
    invoke UninstallHook2
    invoke UninstallHook3
    invoke DeregisterShellHookWindow,hWnd
    invoke EndDialog,hWnd,0
;--------------------------------------------------------------------------------------------------------------
  .elseif eax==WM_SIZE || eax==WM_INITDIALOG
    invoke GetClientRect,hWnd,addr rt
    mov edi,rt.right
    mov esi,rt.bottom
    invoke GetDlgItem,hWnd,id+1
    mov ebx,eax
    invoke GetWindowRect,ebx,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2
    .if hght==0
      mov edx,rt.bottom
      sub edx,rt.top
      mov hght,edx
    .endif
    invoke SetWindowPos,ebx,0,0,0,edi,hght,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED
    invoke GetDlgItem,hWnd,id
    mov ebx,eax
    sub esi,rt.bottom
    invoke SetWindowPos,ebx,0,0,0,edi,esi,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED
    .if uMsg==WM_INITDIALOG
      mov eax,hWnd
      mov hwnd,eax
      invoke RegisterWindowMessage,offset _shellhook
      mov WM_SHELLHOOK,eax
      invoke SetWindowLong,ebx,GWL_WNDPROC,offset SubClass
      mov oldproc,eax
      invoke GetSystemMetrics,SM_CXSCREEN
      shl eax,2
      mov ebx,eax
      invoke SendDlgItemMessage,hWnd,id,LB_SETHORIZONTALEXTENT,ebx,0
      invoke SendDlgItemMessage,hWnd,id+1,LB_SETHORIZONTALEXTENT,ebx,0
      jmp @f
    .endif
;--------------------------------------------------------------------------------------------------------------
  .elseif eax==WM_COMMAND && wParam==id+1 && lParam==0    ; (Clear)
@@:  
    invoke SendDlgItemMessage,hWnd,id,LB_RESETCONTENT,0,0
    invoke SendDlgItemMessage,hWnd,id+1,LB_RESETCONTENT,0,0
    invoke SendDlgItemMessage,hWnd,id+1,LB_ADDSTRING,0,offset _head
    invoke ClearCount
;--------------------------------------------------------------------------------------------------------------
  .elseif eax==WM_COMMAND && wParam==id+2 && lParam==0
    invoke ListToFile
    invoke MessageBeep,0
;--------------------------------------------------------------------------------------------------------------
  .elseif eax==WM_COMMAND && wParam==id && lParam==0     ; (Hook1/UnHook1)
    invoke IsHook1
    .if eax==0
      invoke ClearCount
      invoke InstallHook1,hWnd  ; eax
      .if eax!=0
        mov ebx,offset _unhook1
@@:
        invoke GetMenu,hWnd
        invoke ModifyMenu,eax,wParam,MF_BYCOMMAND or MF_STRING,wParam,ebx
        invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .endif
    .else
      invoke UninstallHook1
      .if eax!=0
        mov ebx,offset _hook1
        invoke PostMessage,HWND_BROADCAST,WM_NULL,0,0
        jmp @b
      .endif
    .endif
;--------------------------------------------------------------------------------------------------------------
  .elseif eax==WM_COMMAND && wParam==id+10 && lParam==0    ; (Hook2/UnHook2)
    invoke IsHook2
    .if eax==0
      invoke ClearCount    
      invoke InstallHook2,hWnd ; eax
      .if eax!=0
        mov ebx,offset _unhook2
@@:
        invoke GetMenu,hWnd
        invoke ModifyMenu,eax,wParam,MF_BYCOMMAND or MF_STRING,wParam,ebx
        invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .endif
    .else
      invoke UninstallHook2
      .if eax!=0
        mov ebx,offset _hook2
        invoke PostMessage,HWND_BROADCAST,WM_NULL,0,0
        jmp @b
      .endif
    .endif
;--------------------------------------------------------------------------------------------------------------
  .elseif eax==WM_COMMAND && wParam==id+11 && lParam==0     ; (Hook3/UnHook3)
    invoke IsHook3
    .if eax==0
      invoke ClearCount
      invoke InstallHook3,hWnd ; eax
      .if eax!=0
        mov ebx,offset _unhook3
@@:
        invoke GetMenu,hWnd
        invoke ModifyMenu,eax,wParam,MF_BYCOMMAND or MF_STRING,wParam,ebx
        invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .endif
    .else
      invoke UninstallHook3
      .if eax!=0
        mov ebx,offset _hook3
        invoke PostMessage,HWND_BROADCAST,WM_NULL,0,0
        jmp @b
      .endif
    .endif
;--------------------------------------------------------------------------------------------------------------
; MSDN: "It is recommended that you do not use it in new programs because it might be altered or unavailable in subsequent versions of Windows."

  .elseif eax==WM_COMMAND && wParam==id+12 && lParam==0  ; (Register/Deregister ShellHookWindow)
    .if shm==0
      invoke RegisterShellHookWindow,hWnd
      .if eax==TRUE
        inc shm
        mov ebx,offset _unshw
@@:
        invoke GetMenu,hWnd
        invoke ModifyMenu,eax,wParam,MF_BYCOMMAND or MF_STRING,wParam,ebx
        invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .endif
    .else
      invoke DeregisterShellHookWindow,hWnd
      .if eax==TRUE
        mov shm,0
        mov ebx,offset _shw
        jmp @b
      .endif
    .endif
;--------------------------------------------------------------------------------------------------------------
  .elseif eax==WM_SHELLHOOK
  
    invoke GetDlgItemInt,hwnd,id+2,0,0
    inc eax
    mov ebx,eax
    invoke SetDlgItemInt,hwnd,id+2,eax,0
    invoke GetDlgItem,hwnd,id+2
    invoke InvalidateRect,eax,0,1
    .if wParam==HSHELL_WINDOWCREATED
      mov edx,offset _shw_crea
      jmp @f
    .elseif wParam==HSHELL_WINDOWDESTROYED
      mov edx,offset _shw_dest
@@:
;      invoke AddLine,hwnd,lParam,edx,ebx

      push edx
      invoke GetWinfo,lParam,addr wi
      pop edx
      invoke wsprintf,addr buf,offset _event2,ebx,edx,lParam,wi.v1,wi.v2,wi.v3,wi.v4,wi.v15,wi.v16,wi.v17
      invoke SendDlgItemMessage,hWnd,id,LB_ADDSTRING,0,addr buf

    .endif
;--------------------------------------------------------------------------------------------------------------
  .elseif eax==WM_CTLCOLORSTATIC || eax==WM_CTLCOLORDLG
    invoke GetStockObject,WHITE_BRUSH
    jmp @f
;--------------------------------------------------------------------------------------------------------------
  .elseif eax==WM_CTLCOLORLISTBOX
    invoke GetDlgCtrlID,lParam
    .if eax==id+1
      invoke SetBkMode,wParam,TRANSPARENT
      invoke GetStockObject,WHITE_BRUSH
    .else
      xor eax,eax
      jmp @f
    .endif
;--------------------------------------------------------------------------------------------------------------
  .else
    xor eax,eax
    jmp @f
  .endif
  xor eax,eax
  inc eax
@@:
  ret
DlgProc endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

start:
  mov icc.dwSize,sizeof icc
  mov icc.dwICC,ICC_INTERNET_CLASSES or 0FFFFh  ; (ICC_ALL_CLASSES)
  invoke InitCommonControlsEx,addr icc
  invoke GetModuleHandle,0
  invoke DialogBoxParam,eax,id,0,offset DlgProc,0
  invoke ExitProcess,eax
end start

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
