; _createwnd_dll
; draft v.2012-01-08

.386
.model flat,stdcall
option casemap:none

; ml   /I\masm32\include ...
; link /libpath:\masm32\lib /dll /def:%name%.def /section:.bss,S ...

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32

;CREATESTRUCT struct             ; (for msam32)
;   lpCreateParams    DWORD ?
;   hInstance         DWORD ?
;   hMenu             DWORD ?
;   hWndParent        DWORD ?
;   ly                DWORD ?
;   lx                DWORD ?
;   y                 DWORD ?
;   x                 DWORD ?
;   style             DWORD ?
;   lpszName          DWORD ?
;   lpszClass         DWORD ?
;   ExStyle           DWORD ?
;CREATESTRUCT ends

;CBT_CREATEWND struct
;   lpcs              DWORD ?    ; LPCREATESTRUCT
;   hWndInsertAfter   DWORD ?
;CBT_CREATEWND ends

;CBTACTIVATESTRUCT struct
;    fMouse           DWORD ?    ;  BOOL
;    hWndActive       DWORD ?
;CBTACTIVATESTRUCT ends

WINFO struct
    v1     DWORD ?  ; Tid
    v2     DWORD ?  ; Pid
    v3     DWORD ?  ; Id
    v4     DWORD ?  ; Userdata
    v5     DWORD ?  ; Style
    v6     DWORD ?  ; ExStyle
    v7     DWORD ?  ; Left
    v8     DWORD ?  ; Top
    v9     DWORD ?  ; Width
    v10    DWORD ?  ; Height
    v11    DWORD ?  ; gaParent
    v12    DWORD ?  ; gwlParent
    v13    DWORD ?  ; gParent
    v14    DWORD ?  ; gwOwner
    v15    DWORD ?  ; lpClass
    v16    DWORD ?  ; lpSmName
    v17    DWORD ?  ; lpGwtName
WINFO ends

.const
  id   equ 100
.data
 _0     db "  MoveSize        ",0
 _1     db "  MinMax          ",0
;_2     db "Qs",0
 _3     db " *CreateWnd       ",0
 _4     db "  DestroyWnd      ",0
 _5     db "  Activate        ",0
;_6     db "ClickSkipped",0
;_7     db "KeySkipped",0
;_8     db "SysCommand",0
 _9     db "  SetFocus        ",0
 _10    db " WindowCreated    ",0
 _11    db " WindowDestroyed  ",0

 _frmt1 db "%5.4d%s%8.8lX  %s%6.4lu%6.4lu%10.8lX%10.8lX%10.8lX%10.8lX%10.8lX%10.8lX%10.8lX%10.8lX%10.8lX%10.8lX%10.8lX%10.8lX%10.8lX  [%d,%d,%d*%d]  [%d,%d,%d*%d]    ""%s"" - ""%s"" / ""%s"" / ""%s""",0

 _frmt2 db "%5.4d%s%8.8lX  %s%6.4lu%6.4lu%10.8lX  *%17.8lX  *%17.8lX%10.8lX%10.8lX%10.8lX  *%17.8lX  *%17.8lX  *         [%d,%d,%d*%d]  *    ""%s"" - * / ""%s"" / ""%s""",0

 _event db "%5.4d%s%8.8lX  %s%6.4lu%6.4lu%10.8lX  .%17.8lX  ... ""%s"" - ""."" / ""%s"" / ""%s""",0
 
 _msg   db "%5.4d%7.4lX%19.8lX  .%6.4lu%6.4lu%10.8lX  .%17.8lX  ... ""%s""",0
 
 _message db "%7.4d           ",0
 
 _ft    db "#"
 _d     db "%d",0

 _crash db "!crash!",0 
 _SysIP db "SysIPAddress32",0
 hinst  dd 0

.data?
 hhook1 dd ?
 hhook2 dd ?
 hhook3 dd ?
 hwnd   dd ?

.code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DllEntry proc hInst:HINSTANCE,reason:DWORD,reserved1:DWORD
  .if reason==DLL_PROCESS_ATTACH
    mov eax,hInst
    mov hinst,eax
  .endif
  mov eax,TRUE
  ret
DllEntry Endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;GetWinfo proc uses ebx hWnd:HWND,lpWi:DWORD
;  local pid:DWORD
;  local rt:RECT
;  local buf1[MAX_PATH]:BYTE
;  local buf2[MAX_PATH]:BYTE
;  local buf3[MAX_PATH]:BYTE
;  mov ebx,lpWi
;  assume ebx:PTR WINFO
;  invoke GetWindowThreadProcessId,hWnd,addr pid
;  mov [ebx].v1,eax 
;  mov eax,pid
;  mov [ebx].v2,eax
;  invoke GetWindowLong,hWnd,GWL_ID
;  mov [ebx].v3,eax
;  invoke GetWindowLong,hWnd,GWL_USERDATA
;  mov [ebx].v4,eax
;  invoke GetWindowLong,hWnd,GWL_STYLE
;  mov [ebx].v5,eax
;  invoke GetWindowLong,hWnd,GWL_EXSTYLE
;  mov [ebx].v6,eax
;  invoke GetWindowRect,hWnd,addr rt
;  mov eax,rt.left
;  mov [ebx].v7,eax
;  mov eax,rt.top
;  mov [ebx].v8,eax
;  mov eax,rt.right
;  sub eax,rt.left
;  mov [ebx].v9,eax
;  mov eax,rt.bottom
;  sub eax,rt.top
;  mov [ebx].v10,eax
;  invoke GetAncestor,hWnd,GA_PARENT
;  mov [ebx].v11,eax
;  invoke GetWindowLong,hWnd,GWL_HWNDPARENT
;  mov [ebx].v12,eax
;  invoke GetParent,hWnd
;  mov [ebx].v13,eax
;  invoke GetWindow,hWnd,GW_OWNER
;  mov [ebx].v14,eax
;  invoke GetClassName,hWnd,addr buf1,MAX_PATH-1
;  lea eax,buf1
;  mov [ebx].v15,eax
;  invoke SendMessage,hWnd,WM_GETTEXT,MAX_PATH-1,addr buf2
;  lea eax,buf2
;  mov [ebx].v16,eax
;  invoke GetWindowText,hWnd,addr buf3,MAX_PATH-1
;  lea eax,buf3
;  mov [ebx].v17,eax
;  assume ebx:nothing
;  ret
;GetWinfo endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AddLine proc uses ebx edi esi hW:HWND,hWnd:HWND,val:DWORD,count:DWORD

  local tid:DWORD
  local pid:DWORD
  local v6:DWORD
  local v9:DWORD
  local buf[1024]:BYTE
  local bu1[256]:BYTE
  local bu3[64]:BYTE
  local bu4[64]:BYTE
  local bu5[2]:BYTE  
  local bu[64]:BYTE

  mov byte ptr[bu5],'.'
  mov byte ptr[bu5+1],0

  invoke FindWindowEx,HWND_MESSAGE,0,0,0
  invoke GetAncestor,eax,GA_PARENT
  mov edi,eax                            ;  (class "Message")
  invoke GetAncestor,hWnd,GA_ROOT
  mov esi,eax
  .if eax==edi
    mov byte ptr [bu5],'m'
  .else
    invoke GetWindow,hWnd,GW_OWNER
    .if eax!=0
      mov byte ptr [bu5],'o'
    .else
      .if esi==hWnd
        mov byte ptr [bu5],'u'
      .else
    
      .endif
    .endif
  .endif

  invoke GetWindowThreadProcessId,hWnd,addr pid
  mov tid,eax
  invoke GetWindowLong,hWnd,GWL_ID
  mov v6,eax
  invoke GetWindowLong,hWnd,GWL_USERDATA
  mov v9,eax
  mov byte ptr [bu1],0
  invoke GetClassName,hWnd,addr bu1,255
  mov byte ptr [bu3],0    
  invoke SendMessageTimeout,hWnd,WM_GETTEXT,63,addr bu3,SMTO_ABORTIFHUNG,300,0
  mov byte ptr [bu4],0
  invoke GetWindowText,hWnd,addr bu4,63
  invoke wsprintf,addr buf,offset _event,count,val,hWnd,addr bu5,tid,pid,v6,v9,addr bu1,addr bu3,addr bu4
@@:
  invoke GetDlgItem,hW,id
  mov ecx,eax
  invoke SendMessageTimeout,ecx,LB_ADDSTRING,0,addr buf,SMTO_ABORTIFHUNG,300,0
  ret
AddLine endp

;!!;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AddString proc uses ebx edi esi wh:DWORD,nCode:UINT,hWnd:HWND,lpStruct:DWORD
  local pid:DWORD
  local tid:DWORD
  local v1:DWORD
  local v2:DWORD
  local v3:DWORD
  local v4:DWORD
  local v5:DWORD
  local v6:DWORD
  local v7:DWORD
  local v8:DWORD
  local v9:DWORD
  local v10:DWORD
  local v11:DWORD
  local v12:DWORD
  local count:DWORD
  local var:DWORD  
  local buf[1024]:BYTE
  local bu1[256]:BYTE
  local bu2[256]:BYTE
  local bu3[64]:BYTE
  local bu4[64]:BYTE
  local bu5[2]:BYTE
  local bu6[16]:BYTE
  local rt:RECT

  invoke GetDlgItemInt,hwnd,id+2,0,0
  inc eax
  mov count,eax
  invoke SetDlgItemInt,hwnd,id+2,eax,0
  invoke GetDlgItem,hwnd,id+2
  invoke InvalidateRect,eax,0,1

  mov byte ptr[bu5],'.'
  mov byte ptr[bu5+1],0
  .if hWnd!=0
    invoke FindWindowEx,HWND_MESSAGE,0,0,0
    invoke GetAncestor,eax,GA_PARENT
    mov edi,eax                            ;  (class "Message")
    invoke GetAncestor,hWnd,GA_ROOT
    mov esi,eax
    .if eax==edi
      mov byte ptr [bu5],'m'
    .else
      invoke GetWindow,hWnd,GW_OWNER
      .if eax!=0
        mov byte ptr [bu5],'o'
      .else
        .if esi==hWnd
          mov byte ptr [bu5],'u'
        .else
        .endif
      .endif
    .endif
    invoke GetWindowThreadProcessId,hWnd,addr pid
    mov tid,eax
    invoke GetWindowLong,hWnd,GWL_ID
    mov v6,eax
    invoke GetWindowLong,hWnd,GWL_USERDATA
    mov v9,eax
    mov byte ptr [bu3],0    
    invoke SendMessageTimeout,hWnd,WM_GETTEXT,63,addr bu3,SMTO_ABORTIFHUNG,300,0
    mov byte ptr [bu4],0
    invoke GetWindowText,hWnd,addr bu4,63
    invoke GetAncestor,hWnd,GA_PARENT
    mov v1,eax
    invoke GetParent,hWnd
    mov v2,eax
    invoke GetWindow,hWnd,GW_OWNER
    mov v3,eax
    invoke GetWindowLong,hWnd,GWL_STYLE
    mov v4,eax
    invoke GetWindowLong,hWnd,GWL_EXSTYLE
    mov v5,eax
    invoke GetWindowLong,hWnd,GWL_ID
    mov v6,eax
    invoke GetWindowLong,hWnd,GWL_HWNDPARENT
    mov v10,eax
    invoke GetWindowLong,hWnd,GWL_USERDATA
    mov v9,eax
    invoke GetWindowThreadProcessId,hWnd,addr pid
    mov tid,eax
    mov byte ptr [bu3],0
    mov byte ptr [bu3+1],0
    mov byte ptr[bu3],0
    mov byte ptr [bu4],0
    invoke GetWindowText,hWnd,addr bu4,63
    invoke GetWindowRect,hWnd,addr rt
  .endif

  .if wh==WH_CBT && nCode==HCBT_CREATEWND
    mov var,offset _3
    mov edi,lpStruct
    assume edi:PTR CBT_CREATEWND
    mov esi,[edi].lpcs
    assume esi:PTR CREATESTRUCT
    
;    invoke FindWindowEx,HWND_MESSAGE,0,0,0
;    invoke GetAncestor,eax,GA_PARENT
;    mov ecx,[esi].hWndParent
;    .if ecx==0
;      mov al,'u'
;    .elseif ecx==eax
;      mov al,'m'
;    .else
;      mov eax,[esi].style
;      and eax,WS_CHILD
;      .if eax!=0
;        mov al,'c'
;      .else
;        mov al,'o'
;      .endif
;    .endif
;    mov byte ptr[bu5],al

    mov ecx,[esi].hWndParent
    .if v2!=0
      mov al,'c'
    .else
      .if ecx==0
        mov al,'u'
      .else
        .if ecx==v1
          mov al,'m'
        .else
          mov al,'o'
        .endif
      .endif
    .endif
    mov byte ptr[bu5],al

    mov eax,[esi].lpszClass
    mov ecx,eax
    shr eax,16
    .if eax!=0
      invoke lstrcpy,addr bu1,ecx
    .else
      .if ecx<0C000h
        invoke wsprintf,addr bu1,offset _ft,ecx
      .else
        invoke GetClipboardFormatName,ecx,addr bu1,255
      .endif
    .endif
    mov eax,[esi].lpszName
    .if eax==0
      mov byte ptr [bu2],0
    .else
      invoke lstrcpy,addr bu2,eax
    .endif
;    invoke lstrcmpi,addr bu1,offset _SysIP
;    .if eax==0
;      invoke lstrcpy,addr bu3,offset _crash
;    .else
      invoke SendMessageTimeout,hWnd,WM_GETTEXT,63,addr bu3,SMTO_ABORTIFHUNG,300,0  ; => !! crash: 1) class "SysIPAddress32", 2) UEdit-class "EditContol", 3) Winspector-class "QHTM_Window_Class_001", 4)...
;    .endif

    mov ecx,rt.right
    mov edx,rt.bottom
    sub ecx,rt.left
    sub edx,rt.top
    mov eax,[esi].ExStyle
    mov v7,eax
    mov eax,[esi].hWndParent
    mov v8,eax
    mov ebx,[esi].hInstance
    mov eax,[esi].style
    mov v11,eax
    mov eax,[esi].hMenu
    mov v12,eax
    invoke wsprintf,addr buf,offset _frmt1,count,var,hWnd,addr bu5,tid,pid,v6,v12,v9,v8,v1,v10,v2,v3,v11,v4,v7,v5,ebx,rt.left,rt.top,ecx,edx,[esi].x,[esi].y,[esi].lx,[esi].ly,addr bu1,addr bu2,addr bu3,addr bu4
    assume esi:nothing
    assume edi:nothing

  .elseif wh==WH_CBT && HCBT_MOVESIZE
    mov eax,offset _0
    jmp @f
  .elseif wh==WH_CBT && nCode==HCBT_MINMAX
    mov eax,offset _1
    jmp @f
  .elseif wh==WH_CBT && nCode==HCBT_DESTROYWND
    mov eax,offset _4
    jmp @f
  .elseif wh==WH_CBT && nCode==HCBT_ACTIVATE
    mov eax,offset _5
    jmp @f
  .elseif wh==WH_CBT && nCode==HCBT_SETFOCUS
    mov eax,offset _9
@@:
    mov var,eax
    mov byte ptr[bu5],'.'
    mov byte ptr[bu5+1],0
    invoke FindWindowEx,HWND_MESSAGE,0,0,0
    invoke GetAncestor,eax,GA_PARENT
    mov edi,eax                            ;  (class "Message")
    invoke GetAncestor,hWnd,GA_ROOT
    mov esi,eax
    .if eax==edi
      mov byte ptr [bu5],'m'
    .else
      invoke GetWindow,hWnd,GW_OWNER
      .if eax!=0
        mov byte ptr [bu5],'o'
      .else
        .if esi==hWnd
          mov byte ptr [bu5],'u'
        .else
        .endif
      .endif
    .endif
    mov byte ptr [bu1],0
    invoke GetClassName,hWnd,addr bu1,255
    mov ecx,rt.right
    mov edx,rt.bottom
    sub ecx,rt.left
    sub edx,rt.top
    invoke wsprintf,addr buf,offset _frmt2,count,var,hWnd,addr bu5,tid,pid,v6,v9,v1,v10,v2,v3,v4,v5,rt.left,rt.top,ecx,edx,addr bu1,addr bu3,addr bu4
    
  .elseif wh==WH_SHELL && nCode!=HSHELL_WINDOWCREATED || nCode!=HSHELL_WINDOWDESTROYED
    jmp @ret
  .elseif wh==WH_SHELL && nCode==HSHELL_WINDOWCREATED
    mov eax,offset _10
    jmp @1
  .elseif wh==WH_SHELL && nCode==HSHELL_WINDOWDESTROYED
    mov eax,offset _11
@1:
    mov var,eax
    jmp @b

  .elseif wh==WH_CALLWNDPROC && nCode==HC_ACTION
  
    mov ebx,lpStruct
    assume ebx:PTR CWPSTRUCT
    mov esi,[ebx].hwnd
    invoke GetAncestor,esi,GA_ROOT
    mov edx,[ebx].message
    .if eax!=hwnd && (edx==WM_NCCREATE || edx==WM_CREATE || edx==WM_DESTROY || edx==WM_NCDESTROY || edx==WM_INITDIALOG || edx==WM_CLOSE || edx==WM_MDICREATE || edx==WM_MDIDESTROY || edx==42h || edx==43h)
      invoke wsprintf,addr bu6,offset _message,edx
      assume ebx:nothing
      jmp @b
    .else
      assume ebx:nothing    
      jmp @ret
    .endif

  .endif
  invoke GetDlgItem,hwnd,id
  mov ecx,eax
  invoke SendMessageTimeout,ecx,LB_ADDSTRING,0,addr buf,SMTO_ABORTIFHUNG,300,0
@ret:  
  ret
AddString endp

;!!;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;HookProc1 proc uses ebx edi esi nCode:UINT,wParam:WPARAM,lParam:LPARAM  ; (CBTProc)
;
;  .if nCode!=HCBT_QS && nCode!=HCBT_CLICKSKIPPED && nCode!=HCBT_KEYSKIPPED && nCode!=HCBT_SYSCOMMAND
;    invoke AddString,WH_CBT,nCode,wParam,lParam
;  .elseif nCode==HCBT_QS
;    mov ebx,id+6
;    jmp @f
;  .elseif nCode==HCBT_CLICKSKIPPED
;    mov ebx,id+4
;    jmp @f
;  .elseif nCode==HCBT_KEYSKIPPED
;    mov ebx,id+5
;    jmp @f
;  .elseif nCode==HCBT_SYSCOMMAND
;    mov ebx,id+3
;@@:
;    invoke GetDlgItemInt,hwnd,ebx,0,0
;    inc eax
;    invoke SetDlgItemInt,hwnd,ebx,eax,0
;    invoke GetDlgItem,hwnd,ebx
;    invoke InvalidateRect,eax,0,1
;  .endif
;  ret
;HookProc1 endp

;!!;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HookProc1 proc uses ebx edi esi nCode:UINT,wParam:WPARAM,lParam:LPARAM  ; (CBTProc)
  local pid:DWORD
  local tid:DWORD
  local v1:DWORD
  local v2:DWORD
  local v3:DWORD
  local v4:DWORD
  local v5:DWORD
  local v6:DWORD
  local v7:DWORD
  local v8:DWORD
  local v9:DWORD
  local v10:DWORD
  local v11:DWORD
  local v12:DWORD
  local count:DWORD
  local var:DWORD  
  local buf[1024]:BYTE
  local bu1[256]:BYTE
  local bu2[256]:BYTE
  local bu3[64]:BYTE
  local bu4[64]:BYTE
  local bu5[2]:BYTE
  local rt:RECT

  invoke GetDlgItemInt,hwnd,id+2,0,0
  inc eax
  mov count,eax
  invoke SetDlgItemInt,hwnd,id+2,eax,0
  invoke GetDlgItem,hwnd,id+2
  invoke InvalidateRect,eax,0,1

  mov byte ptr[bu5],'.'
  mov byte ptr[bu5+1],0

  .if nCode!=HCBT_QS && nCode!=HCBT_CLICKSKIPPED &&  nCode!=HCBT_KEYSKIPPED &&  nCode!=HCBT_SYSCOMMAND
  
    mov byte ptr[bu5],'.'
    mov byte ptr[bu5+1],0
  
    invoke FindWindowEx,HWND_MESSAGE,0,0,0
    invoke GetAncestor,eax,GA_PARENT
    mov edi,eax                            ;  (class "Message")
    invoke GetAncestor,wParam,GA_ROOT
    mov esi,eax
    .if eax==edi
      mov byte ptr [bu5],'m'
    .else
      invoke GetWindow,wParam,GW_OWNER
      .if eax!=0
        mov byte ptr [bu5],'o'
      .else
        .if esi==wParam
          mov byte ptr [bu5],'u'
        .else
      
        .endif
      .endif
    .endif
  
    invoke GetWindowThreadProcessId,wParam,addr pid
    mov tid,eax
    invoke GetWindowLong,wParam,GWL_ID
    mov v6,eax
    invoke GetWindowLong,wParam,GWL_USERDATA
    mov v9,eax
    mov byte ptr [bu3],0    
    invoke SendMessageTimeout,wParam,WM_GETTEXT,63,addr bu3,SMTO_ABORTIFHUNG,300,0
    mov byte ptr [bu4],0
    invoke GetWindowText,wParam,addr bu4,63
    
    invoke GetAncestor,wParam,GA_PARENT
    mov v1,eax
    invoke GetParent,wParam
    mov v2,eax
    invoke GetWindow,wParam,GW_OWNER
    mov v3,eax
    invoke GetWindowLong,wParam,GWL_STYLE
    mov v4,eax
    invoke GetWindowLong,wParam,GWL_EXSTYLE
    mov v5,eax
    invoke GetWindowLong,wParam,GWL_ID
    mov v6,eax
    invoke GetWindowLong,wParam,GWL_HWNDPARENT
    mov v10,eax
    invoke GetWindowLong,wParam,GWL_USERDATA
    mov v9,eax

    invoke GetWindowThreadProcessId,wParam,addr pid
    mov tid,eax
    mov byte ptr [bu3],0
    mov byte ptr [bu3+1],0

    mov byte ptr[bu3],0
    mov byte ptr [bu4],0
    invoke GetWindowText,wParam,addr bu4,63
    invoke GetWindowRect,wParam,addr rt

;    invoke wsprintf,addr buf,offset _event,count,val,wParam,addr bu5,tid,pid,v6,v9,addr bu1,addr bu3,addr bu4
;  @@:
;    invoke GetDlgItem,hW,id
;    mov ecx,eax
;    invoke SendMessageTimeout,ecx,LB_ADDSTRING,0,addr buf,SMTO_ABORTIFHUNG,300,0
    
    .if nCode==HCBT_CREATEWND
    
      mov var,offset _3

      mov edi,lParam
      assume edi:PTR CBT_CREATEWND
      mov esi,[edi].lpcs
      assume esi:PTR CREATESTRUCT

;      invoke FindWindowEx,HWND_MESSAGE,0,0,0
;      invoke GetAncestor,eax,GA_PARENT
;      mov ecx,[esi].hWndParent
;      .if ecx==0
;        mov al,'u'
;      .elseif ecx==eax
;        mov al,'m'
;      .else
;        mov eax,[esi].style
;        and eax,WS_CHILD
;        .if eax!=0
;          mov al,'c'
;        .else
;          mov al,'o'
;        .endif
;      .endif
;      mov byte ptr[bu5],al
  
      mov ecx,[esi].hWndParent
      .if v2!=0
        mov al,'c'
      .else
        .if ecx==0
          mov al,'u'
        .else
          .if ecx==v1
            mov al,'m'
          .else
            mov al,'o'
          .endif
        .endif
      .endif
      mov byte ptr[bu5],al
  
      mov eax,[esi].lpszClass
      mov ecx,eax
      shr eax,16
      .if eax!=0
        invoke lstrcpy,addr bu1,ecx
      .else
        .if ecx<0C000h
          invoke wsprintf,addr bu1,offset _ft,ecx
        .else
          invoke GetClipboardFormatName,ecx,addr bu1,255
        .endif
      .endif
      
      mov eax,[esi].lpszName
      .if eax==0
        mov byte ptr [bu2],0
      .else
        invoke lstrcpy,addr bu2,eax
      .endif
      
  
;      invoke lstrcmpi,addr bu1,offset _SysIP
;      .if eax==0
;        invoke lstrcpy,addr bu3,offset _crash
;      .else
        invoke SendMessageTimeout,wParam,WM_GETTEXT,63,addr bu3,SMTO_ABORTIFHUNG,300,0  ; => !! crash: 1) class "SysIPAddress32", 2) UEdit-class "EditContol", 3) Winspector-class "QHTM_Window_Class_001", 4)...
;      .endif
  

      mov ecx,rt.right
      mov edx,rt.bottom
      sub ecx,rt.left
      sub edx,rt.top
      
      mov eax,[esi].ExStyle
      mov v7,eax
      mov eax,[esi].hWndParent
      mov v8,eax
      mov ebx,[esi].hInstance
      mov eax,[esi].style
      mov v11,eax
      mov eax,[esi].hMenu
      mov v12,eax

      invoke wsprintf,addr buf,offset _frmt1,count,var,wParam,addr bu5,tid,pid,v6,v12,v9,v8,v1,v10,v2,v3,v11,v4,v7,v5,ebx,rt.left,rt.top,ecx,edx,[esi].x,[esi].y,[esi].lx,[esi].ly,addr bu1,addr bu2,addr bu3,addr bu4

      assume esi:nothing
      assume edi:nothing
      
    .else
      mov byte ptr[bu5],'.'
      mov byte ptr[bu5+1],0
      invoke FindWindowEx,HWND_MESSAGE,0,0,0
      invoke GetAncestor,eax,GA_PARENT
      mov edi,eax                            ;  (class "Message")
      invoke GetAncestor,wParam,GA_ROOT
      mov esi,eax
      .if eax==edi
        mov byte ptr [bu5],'m'
      .else
        invoke GetWindow,wParam,GW_OWNER
        .if eax!=0
          mov byte ptr [bu5],'o'
        .else
          .if esi==wParam
            mov byte ptr [bu5],'u'
          .else
          .endif
        .endif
      .endif
      mov byte ptr [bu1],0
      invoke GetClassName,wParam,addr bu1,255
      .if nCode==HCBT_MOVESIZE
        mov eax,offset _0
      .elseif nCode==HCBT_MINMAX
        mov eax,offset _1
      .elseif nCode==HCBT_DESTROYWND
        mov eax,offset _4
      .elseif nCode==HCBT_ACTIVATE
        mov eax,offset _5
      .elseif nCode==HCBT_SETFOCUS
        mov eax,offset _9
      .endif
      mov var,eax
      mov ecx,rt.right
      mov edx,rt.bottom
      sub ecx,rt.left
      sub edx,rt.top
      invoke wsprintf,addr buf,offset _frmt2,count,var,wParam,addr bu5,tid,pid,v6,v9,v1,v10,v2,v3,v4,v5,rt.left,rt.top,ecx,edx,addr bu1,addr bu3,addr bu4
    .endif
    invoke GetDlgItem,hwnd,id
    mov ecx,eax
    invoke SendMessageTimeout,ecx,LB_ADDSTRING,0,addr buf,SMTO_ABORTIFHUNG,300,0
  .else
    .if nCode==HCBT_QS
      mov ebx,id+6
      jmp @f
    .elseif nCode==HCBT_CLICKSKIPPED
      mov ebx,id+4
      jmp @f
    .elseif nCode==HCBT_KEYSKIPPED
      mov ebx,id+5
      jmp @f
    .elseif nCode==HCBT_SYSCOMMAND
      mov ebx,id+3
@@:
      invoke GetDlgItemInt,hwnd,ebx,0,0
      inc eax
      invoke SetDlgItemInt,hwnd,ebx,eax,0
      invoke GetDlgItem,hwnd,ebx
      invoke InvalidateRect,eax,0,1
    .endif
  .endif
  invoke CallNextHookEx,0,nCode,wParam,lParam    ;   (for WinOS>=2k: hhook value is ignored)
  ret
HookProc1 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HookProc2 proc uses ebx edi esi nCode:UINT, wParam:WPARAM, lParam:LPARAM  ; (CallWndProc)
  local tid:DWORD
  local pid:DWORD
  local v6:DWORD
  local v9:DWORD
  local buf[1024]:BYTE
  local bu[64]:BYTE
  local count:DWORD

  .if nCode==HC_ACTION
    mov ebx,lParam
    assume ebx:PTR CWPSTRUCT
    mov esi,[ebx].hwnd
    invoke GetAncestor,esi,GA_ROOT
    mov edx,[ebx].message
    .if eax!=hwnd && (edx==WM_NCCREATE || edx==WM_CREATE || edx==WM_DESTROY || edx==WM_NCDESTROY || edx==WM_INITDIALOG || edx==WM_CLOSE || edx==WM_MDICREATE || edx==WM_MDIDESTROY || edx==42h || edx==43h)
      invoke GetDlgItemInt,hwnd,id+2,0,0
      inc eax
      mov count,eax
      invoke SetDlgItemInt,hwnd,id+2,eax,0
      invoke GetDlgItem,hwnd,id+2
      invoke InvalidateRect,eax,0,1
      invoke GetWindowThreadProcessId,esi,addr pid
      mov tid,eax
      invoke GetWindowLong,esi,GWL_ID
      mov v6,eax
      invoke GetWindowLong,wParam,GWL_USERDATA
      mov v9,eax
      invoke GetClassName,esi,addr bu,63
      invoke wsprintf,addr buf,offset _msg,count,[ebx].message,esi,tid,pid,v6,v9,addr bu
      invoke GetDlgItem,hwnd,id
      mov ecx,eax
      invoke SendMessageTimeout,ecx,LB_ADDSTRING,0,addr buf,SMTO_ABORTIFHUNG,300,0
    .endif
    assume ebx:nothing
  .endif
  invoke CallNextHookEx,0,nCode,wParam,lParam  ;  (for WinOS>=2k)
  ret
HookProc2 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

HookProc3 proc uses ebx edi esi nCode:UINT, wParam:WPARAM, lParam:LPARAM  ; (ShellProc)
  local count:DWORD

  invoke GetDlgItemInt,hwnd,id+2,0,0
  inc eax
  mov count,eax
  invoke SetDlgItemInt,hwnd,id+2,eax,0
  invoke GetDlgItem,hwnd,id+2
  invoke InvalidateRect,eax,0,1

  .if nCode==HSHELL_WINDOWCREATED
    mov ebx,offset _10
    jmp @f

  .elseif nCode==HSHELL_WINDOWDESTROYED
    mov ebx,offset _11
@@:
    invoke AddLine,hwnd,wParam,ebx,count
  .endif
  invoke CallNextHookEx,0,nCode,wParam,lParam  ;  (for WinOS>=2k)
  ret
HookProc3 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InstallHook1 proc hWnd:DWORD
  mov eax,hWnd
  mov hwnd,eax
  mov eax,hhook1
  .if eax==0
    invoke SetWindowsHookEx,WH_CBT,offset HookProc1,hinst,0
    mov hhook1,eax
  .else
    xor eax,eax
  .endif
	ret 
InstallHook1 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InstallHook2 proc hWnd:DWORD
  mov eax,hWnd
  mov hwnd,eax
  mov eax,hhook2
  .if eax==0
    invoke SetWindowsHookEx,WH_CALLWNDPROC,offset HookProc2,hinst,0
    mov hhook2,eax
  .else
    xor eax,eax
  .endif
	ret 
InstallHook2 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InstallHook3 proc hWnd:DWORD
  mov eax,hWnd
  mov hwnd,eax
  mov eax,hhook3
  .if eax==0
    invoke SetWindowsHookEx,WH_SHELL,offset HookProc3,hinst,0
    mov hhook3,eax
  .else
    xor eax,eax
  .endif
	ret 
InstallHook3 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

UninstallHook1 proc
  local buf[16]:BYTE
  mov eax,hhook1
  .if eax!=0
    invoke GetDlgItemInt,hwnd,id+2,0,0
    invoke wsprintf,addr buf,offset _d,eax
    invoke GetDlgItem,hwnd,id
    mov ecx,eax
    invoke SendMessageTimeout,ecx,LB_ADDSTRING,0,addr buf,SMTO_ABORTIFHUNG,300,0
	  invoke UnhookWindowsHookEx,hhook1
	  .if eax!=0
	    mov hhook1,0
	  .endif
	.endif
	ret
UninstallHook1 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

UninstallHook2 proc
  local buf[16]:BYTE
  mov eax,hhook2
  .if eax!=0
    invoke GetDlgItemInt,hwnd,id+2,0,0
    invoke wsprintf,addr buf,offset _d,eax
    invoke GetDlgItem,hwnd,id
    mov ecx,eax
    invoke SendMessageTimeout,ecx,LB_ADDSTRING,0,addr buf,SMTO_ABORTIFHUNG,300,0
	  invoke UnhookWindowsHookEx,hhook2
	  .if eax!=0
	    mov hhook2,0
	  .endif
	.endif
	ret
UninstallHook2 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

UninstallHook3 proc
  local buf[16]:BYTE
  mov eax,hhook3
  .if eax!=0
    invoke GetDlgItemInt,hwnd,id+2,0,0
    invoke wsprintf,addr buf,offset _d,eax
    invoke GetDlgItem,hwnd,id
    mov ecx,eax
    invoke SendMessageTimeout,ecx,LB_ADDSTRING,0,addr buf,SMTO_ABORTIFHUNG,300,0
	  invoke UnhookWindowsHookEx,hhook3
	  .if eax!=0
	    mov hhook3,0
	  .endif
	.endif
	ret
UninstallHook3 endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

IsHook1 proc
  mov eax,hhook1
  ret
IsHook1 endp


IsHook2 proc
  mov eax,hhook2
  ret
IsHook2 endp


IsHook3 proc
  mov eax,hhook3
  ret
IsHook3 endp


End DllEntry
